# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# perl_vendorlib/perl_vendorarch not defined by default prior to F-2
%{!?perl_vendorlib: %global perl_vendorlib %(eval "`perl -V:installvendorlib`"; echo $installvendorlib)}

# We don't really need ExtUtils::MakeMaker ≥ 6.30
%global old_eumm %(perl -MExtUtils::MakeMaker -e 'printf "%d\\n", $ExtUtils::MakeMaker::VERSION < 6.30 ? 1 : 0;' 2>/dev/null || echo 0)

# We need to patch the test suite if we have an old version of Test::More
%global old_test_more %(perl -MTest::More -e 'printf "%d\\n", $Test::More::VERSION < 0.88 ? 1 : 0;' 2>/dev/null || echo 0)

# We won't have MooseX::InsideOut unless we have Tie::RefHash ≥ 1.34
%global have_moosex_insideout %(perl -MTie::RefHash -e 'printf "%d\\n", $Tie::RefHash::VERSION < 1.34 ? 0 : 1;' 2>/dev/null || echo 0)

Name:		perl-MooseX-NonMoose
Version:	0.22
Release:	3.%{__distinit}%{__distvers}
Summary:	Easy subclassing of non-Moose classes
License:	GPL+ or Artistic
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/MooseX-NonMoose/
Source0:	http://search.cpan.org/CPAN/authors/id/D/DO/DOY/MooseX-NonMoose-%{version}.tar.gz
Patch0:		MooseX-NonMoose-0.22-old-eu::mm.patch
Patch1:		MooseX-NonMoose-0.22-old-Test::More.patch
BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(List::MoreUtils)
BuildRequires:	perl(Moose) >= 1.15
BuildRequires:	perl(MooseX::GlobRef)
%if %{have_moosex_insideout}
BuildRequires:	perl(MooseX::InsideOut)
%endif
BuildRequires:	perl(Pod::Coverage::TrustPod)
BuildRequires:	perl(Test::EOL)
BuildRequires:	perl(Test::Fatal)
BuildRequires:	perl(Test::Moose)
BuildRequires:	perl(Test::More)
BuildRequires:	perl(Test::NoTabs)
BuildRequires:	perl(Test::Pod) >= 1.41
BuildRequires:	perl(Test::Pod::Coverage) >= 1.08
BuildRequires:	perl(Tie::RefHash)
Requires:	perl(Moose) >= 1.15
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

%description
MooseX::NonMoose allows for easily subclassing non-Moose classes with Moose,
taking care of the annoying details connected with doing this, such as setting
up proper inheritance from Moose::Object and installing (and inlining, at
make_immutable time) a constructor that makes sure things like BUILD methods
are called. It tries to be as non-intrusive as possible - when this module is
used, inheriting from non-Moose classes and inheriting from Moose classes
should work identically, aside from the few caveats mentioned below. One of the
goals of this module is that including it in a Moose::Exporter-based package
used across an entire application should be possible, without interfering with
classes that only inherit from Moose modules, or even classes that don't
inherit from anything at all.

%prep
%setup -q -n MooseX-NonMoose-%{version}

# We don't really need ExtUtils::MakeMaker ≥ 6.30
%if %{old_eumm}
%patch0 -p1
%endif

# We need to patch the test suite if we have an old version of Test::More
%if %{old_test_more}
%patch1 -p1
%endif

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} \;
find %{buildroot} -depth -type d -exec rmdir {} \; 2>/dev/null
%{_fixperms} %{buildroot}

%check
make test RELEASE_TESTING=1

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes LICENSE README
%{perl_vendorlib}/MooseX/
%{_mandir}/man3/MooseX::NonMoose.3pm*
%{_mandir}/man3/MooseX::NonMoose::InsideOut.3pm*
%{_mandir}/man3/MooseX::NonMoose::Meta::Role::Class.3pm*
%{_mandir}/man3/MooseX::NonMoose::Meta::Role::Constructor.3pm*

%changelog
* Tue Oct 18 2011 Paul Howarth <paul@city-fan.org> 0.22-3
- Fix dist tag for CentOS 6 and Scientific Linux

* Tue Jul  5 2011 Paul Howarth <paul@city-fan.org> 0.22-2
- Rebuild for perl 5.14.1 in Rawhide

* Mon May  9 2011 Paul Howarth <paul@city-fan.org> 0.22-1
- Import from Fedora
- Update to 0.22:
  - Fix issues where the metaclass gets reinitialized after the call to
    'extends' but before 'make_immutable'; this could happen if a role used an
    extension which provided an application_to_class metarole, since the role
    application would then apply a metarole to the class, and metarole
    application currently causes metaclass reinitialization in Moose

* Wed May 04 2011 Iain Arnell <iarnell@gmail.com> 0.21-1
- Update to latest upstream version

* Wed Mar 23 2011 Iain Arnell <iarnell@gmail.com> 0.20-1
- Update to latest upstream version

* Fri Mar 04 2011 Iain Arnell <iarnell@gmail.com> 0.19-1
- Update to latest upstream version

* Wed Feb 16 2011 Iain Arnell <iarnell@gmail.com> 0.18-1
- Update to latest upstream version
- BR perl(MooseX::GlobRef) for additional test coverage

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.17-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Fri Nov 19 2010 Iain Arnell <iarnell@gmail.com> 0.17-1
- Update to latest upstream version

* Wed Nov 03 2010 Iain Arnell <iarnell@gmail.com> 0.16-2
- Requires Moose >= 1.15

* Wed Oct 27 2010 Iain Arnell <iarnell@gmail.com> 0.16-1
- Update to latest upstream version

* Tue Oct 05 2010 Iain Arnell <iarnell@gmail.com> 0.15-1
- Specfile autogenerated by cpanspec 1.78
